Unit IAH5R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, IAH1R_p;

procedure IAH5R(A :Real; B :Real; var C :Array of Real;
                N :Integer; FUNC :Func_F1;
                var CDER :Array of Real; var RF :Array of Real);

implementation

procedure IAH5R(A :Real; B :Real; var C :Array of Real;
                N :Integer; FUNC :Func_F1;
                var CDER :Array of Real; var RF :Array of Real);
var
N2,JN2,J :Integer;
CON :Real;
label
_10,_20,_30;
begin
IAH1R(A,B,C,N,FUNC,RF);
CDER[N-1] := 0.0;
CDER[N-2] := 2*(N-1)*C[N-1];
if ( N < 3 ) 
 then goto _20;
N2 := N-2;
for J:=2 to N2 do
 begin
  JN2 := N2-J+1;
  CDER[JN2-1] := CDER[JN2+1]+2*JN2*C[JN2+0];
_10:
 end;
_20:
CON := 2.0/(B-A);
for J:=1 to N do
 begin
  CDER[J-1] := CDER[J-1]*CON;
_30:
 end;
end;

end.
